/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.commons.chain2.web.servlet;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.chain2.web.MapEntry;

/**
 * <p>Private implementation of <code>Map</code> for servlet parameter
 * name-values[].</p>
 *
 * @version $Id$
 */
final class ServletParamValuesMap implements Map<String, String[]>, Serializable {

    /** serialVersionUID */
    private static final long serialVersionUID = 5373913824627470557L;

    /** HttpServletRequest */
    private transient HttpServletRequest request = null;

    /**
     * Constructor
     *
     * @param req HttpServletRequest
     */
    ServletParamValuesMap(final HttpServletRequest req) {
        this.request = req;
    }

    /**
     * @see java.util.Map#clear()
     */
    @Override
    public void clear() {
        throw new UnsupportedOperationException();
    }

    /**
     * @see java.util.Map#containsKey(java.lang.Object)
     */
    @Override
    public boolean containsKey(final Object key) {
        return this.request.getParameter(toKey(key)) != null;
    }

    /**
     * @see java.util.Map#containsValue(java.lang.Object)
     */
    @Override
    public boolean containsValue(final Object value) {
        return values().contains(String[].class.cast(value));
    }

    /**
     * @see java.util.Map#entrySet()
     */
    @Override
    public Set<Entry<String, String[]>> entrySet() {
        Set<Entry<String, String[]>> set = new HashSet<>();
        for (final String key : Collections.list(this.request.getParameterNames())) {
            set.add(new MapEntry<>(key, this.request.getParameterValues(key), false));
        }
        return set;
    }

    /**
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(final Object o) {
        if (o != this) {
            if (!ServletParamValuesMap.class.isInstance(o)) {
                return false;
            }
            ServletParamValuesMap map = (ServletParamValuesMap) o;
            return this.request.equals(map.request);
        }
        return true;
    }

    /**
     * @see java.util.Map#get(java.lang.Object)
     */
    @Override
    public String[] get(final Object key) {
        return this.request.getParameterValues(toKey(key));
    }

    /**
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        return this.request.hashCode();
    }

    /**
     * @see java.util.Map#isEmpty()
     */
    @Override
    public boolean isEmpty() {
        return size() < 1;
    }

    /**
     * @see java.util.Map#keySet()
     */
    @Override
    public Set<String> keySet() {
        return new HashSet<>(Collections.list(this.request.getParameterNames()));
    }

    /**
     * @see java.util.Map#put(java.lang.Object, java.lang.Object)
     */
    @Override
    public String[] put(final String key, final String[] value) {
        throw new UnsupportedOperationException();
    }

    /**
     * @see java.util.Map#putAll(java.util.Map)
     */
    @Override
    public void putAll(final Map<? extends String, ? extends String[]> map) {
        throw new UnsupportedOperationException();
    }

    /**
     * @see java.util.Map#remove(java.lang.Object)
     */
    @Override
    public String[] remove(final Object key) {
        throw new UnsupportedOperationException();
    }

    /**
     * @see java.util.Map#size()
     */
    @Override
    public int size() {
        return Collections.list(this.request.getParameterNames()).size();
    }

    /**
     * @see java.util.Map#values()
     */
    @Override
    public Collection<String[]> values() {
        List<String[]> list = new ArrayList<>();
        for (final String key : Collections.list(this.request.getParameterNames())) {
            list.add(this.request.getParameterValues(key));
        }
        return list;
    }

    /**
     * to Key String
     * @param key Key
     * @return Key String
     */
    private String toKey(final Object key) {
        if (key == null) {
            throw new IllegalArgumentException();
        }
        return key.toString();
    }

}
